<template>
  <div class="container">
      <div class="row mt-5">
        <div class="col-md-12">
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">Batch Information</h3>
              <div class="card-tools">
                <button class="btn btn-success" @click="newModal"
                  data-toggle="modal" data-target="#addnewCenter">Add new Batch<i class="fas fa-user-plus fa-fw" ></i> 
                </button>
              </div>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
              <div class="mb-3">
                <div class="row">
                  <div class="col-md-2">
                      <strong >Search By : </strong>
                  </div>
                  <div class="col-md-3">
                      <select v-model="queryFiled" class="form-control" id="fileds" placeholder="Select Field">
                          <option value="name">Name</option>
                          <option value="code">Code</option>
                      </select>
                  </div>
                  <div class="col-md-7">
                      <input v-model="query" type="text" class="form-control" placeholder="Search">
                  </div>
                </div>
              </div>
              <div class="table-responsive p-0">
                <table class="table table-hover">
                  <tbody>
                  <tr>
                    <th>ID</th>
                    <th>Name</th>
                    <th>Code</th>
                    <th>Modify</th>
                  </tr>
                  <tr v-for="batch in batches" :key="batch.id">
                    <td> {{ batch.id }}</td>
                    <td> {{ batch.name }}</td>
                    <td>{{ batch.code }}</td>
          
                    <td>
                      <a href="#" @click="editModal(batch)">
                          <i class="fa fa-edit blue"></i>
                      </a>
                      /
                      <a href="#" @click="deleteData(batch.id)">
                          <i class="fa fa-trash red"></i>
                      </a>
                    </td>
                  </tr> 
                  <tr v-show="!batches.length">
                    <td colspan="6">
                        <div class="alert alert-danger" role="alert">
                            Sorry :( No data found.
                        </div>
                    </td>
                  </tr>
                  </tbody>
                </table>
                <pagination v-if="pagination.last_page > 1"
                  :pagination="pagination"
                  :offset="5"
                  @paginate="query === '' ? getData() : searchData()"
                ></pagination>
              </div>
            </div>
            <!-- /.card-body -->
          </div>
          <!-- /.card -->
        </div>
      </div>


      <!-- Modal -->
      <div class="modal fade" id="addnewCenter" tabindex="-1" role="dialog" aria-labelledby="addnewCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">

            <div class="modal-header">
                    <h5 class="modal-title" v-show="!editmode" id="addNewLabel">Add New Batch</h5>
                    <h5 class="modal-title" v-show="editmode" id="addNewLabel">Update Batches' Info</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>

            <form @submit.prevent="editmode ? updateData() : createData()">
              <div class="modal-body">           
                <div class="form-group">         
                  <input v-model="form.name" type="text" name="name"
                  placeholder="name"
                  class="form-control" :class="{ 'is-invalid': form.errors.has('name') }">
                  <has-error :form="form" field="name"></has-error>
                </div>

                <div class="form-group">          
                  <input v-model="form.code" type="text" name="code"
                  placeholder="code"
                  class="form-control" :class="{ 'is-invalid': form.errors.has('code') }">
                  <has-error :form="form" field="code"></has-error>
                </div>

              </div>

              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <button v-show="editmode" type="submit" class="btn btn-success">Update Batch Info</button>
                <button v-show="!editmode" type="submit" class="btn btn-success">Create Batch</button>
              </div>
            </form>
          </div>
        </div>
      </div>
  </div>
</template>

<script>
    export default {
      data(){
          return{
            query: '',
            queryFiled:'name',
            editmode: false,
            batches: {},
              form: new Form({
                  id:'',
                  name:'',
                  code:'',
              }),
              pagination:{
              current_page: 1,
              }
          }
      },
      watch: {
        query:function (newQ, old) {
            if (newQ === '') {
                this.getData()
            } else {
                this.searchData()
            }
        }  
      },
      methods:{      
        // loadUser(){
        //   axios.get("api/batch").then(({data})=>(this.batches=data.data));
        // },
        getData(){
          // axios.get("api/batch").then(({data})=>(this.batches=data.data));
            this.$Progress.start()
            axios.get('/api/batch?page='+this.pagination.current_page)
                .then(response => {
                    this.batches = response.data.data
                    this.pagination = response.data.meta
                    this.$Progress.finish()
                })
                .catch(e => {
                    console.log(e)
                    this.$Progress.fail()
                })
        },
        searchData(){
            this.$Progress.start()
            axios.get('/api/search/batch/'+this.queryFiled+'/'+this.query+'?page='+this.pagination.current_page)
                .then(response => {
                    this.batches = response.data.data
                    this.pagination = response.data.meta
                    this.$Progress.finish()
                })
                .catch(e => {
                    console.log(e)
                    this.$Progress.fail()
                })
        },
        createData(){
          this.$Progress.start();
          this.form.post('api/batch')
          .then(()=>{
                    Fire.$emit('AfterCreate');
                    $('#addnewCenter').modal('hide')

                    toast({
                        type: 'success',
                        title: 'Batch Created in successfully'
                        })
                    this.$Progress.finish();

                })
                 .catch(()=>{
                   this.$Progress.fail();

                })
        },

         updateData(){
                this.$Progress.start();
                // console.log('Editing data');
                this.form.put('api/batch/'+this.form.id)
                .then(() => {
                    // success
                    $('#addnewCenter').modal('hide');
                     swal(
                        'Updated!',
                        'Information has been updated.',
                        'success'
                        )
                        this.$Progress.finish();
                        Fire.$emit('AfterCreate');
                })
                .catch(() => {
                    this.$Progress.fail();
                });

            },

        editModal(batch){
          this.editmode = true;
          this.form.reset();
          $('#addnewCenter').modal('show');
          this.form.fill(batch);                       
        },

        newModal(){
          this.editmode = false;
          this.form.reset();
          $('#addnewCenter').modal('show');
        },    

        deleteData(id){
          swal({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            type: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
          }).then((result) => {
                              // Send request to the server
                              this.form.delete('api/batch/'+id).then(()=>{
                                swal(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                                )  
                              Fire.$emit('AfterCreate');   
                              }).catch(()=> {
                                  swal("Failed!", "There was something wronge.", "warning");
                              });                                
          })
        },
      },

    created(){
      // this.loadUser();
      this.getData();
      Fire.$on('AfterCreate',() => {
              // this.loadUser();
              this.getData();
      });
      // setInterval(() => this.loadUser(), 3000);

    },
    mounted() {
        console.log('Component mounted.')
    }
  }
</script>
